/* defines.h
 *
 * Definitions for Belvedere
 */


// Arduino pin assignments
// Wave Front Maps
#define Nothing       0
#define Wall          255
#define Target        1
#define Robot         254

#define RotateVelocity   100    //drive speed
#define DriveVelocity    200   //drive speed when navigating
#define RoamVelocity     200   //drive speed when roaming
#define CellSize      370   //amount to move robot forward one cell
#define Max_x         17
#define Max_y         23


#define UseCompass    1

//Preset positions  //X is vertical, Y is horizontal

#define Dock_x        6
#define Dock_y        16
#define Kitchen1_x    2
#define Kitchen1_y    13
#define Kitchen2_x    2
#define Kitchen2_y    9
#define FamilyRoom1_x 14
#define FamilyRoom1_y 5
#define FamilyRoom2_x 12
#define FamilyRoom2_y 5
#define LivingRoom1_x 7
#define LivingRoom1_y 20
#define LivingRoom2_x 12
#define LivingRoom2_y 20
#define Entrance_x    


//Rooms
#define NoRoom         0
#define Dock           1
#define Kitchen        2
#define FamilyRoom     3
#define LivingRoom     4

// Absolute Compass Headings

#define CompassHeading1  46
#define CompassHeading2  135
#define CompassHeading3  228
#define CompassHeading4  317

#define DockCompassHeading1  47
#define DockCompassHeading2  133
#define DockCompassHeading3  226
#define DockCompassHeading4  316

#define Kitchen1CompassHeading1  49
#define Kitchen1CompassHeading2  140
#define Kitchen1CompassHeading3  231
#define Kitchen1CompassHeading4  322

#define Kitchen2CompassHeading1  46
#define Kitchen2CompassHeading2  137
#define Kitchen2CompassHeading3  230
#define Kitchen2CompassHeading4  317

#define FamilyRoom1CompassHeading1  45
#define FamilyRoom1CompassHeading2  133
#define FamilyRoom1CompassHeading3  227
#define FamilyRoom1CompassHeading4  317

#define FamilyRoom2CompassHeading1  44
#define FamilyRoom2CompassHeading2  133
#define FamilyRoom2CompassHeading3  226
#define FamilyRoom2CompassHeading4  313

#define LivingRoom1CompassHeading1  46
#define LivingRoom1CompassHeading2  134
#define LivingRoom1CompassHeading3  228
#define LivingRoom1CompassHeading4  317

#define LivingRoom2CompassHeading1  46
#define LivingRoom2CompassHeading2  134
#define LivingRoom2CompassHeading3  228
#define LivingRoom2CompassHeading4  317

#define HeadingThreshold1  3
#define HeadingThreshold2  1
#define TurnOffset       7
#define SharpIRThresholdRight   220
#define SharpIRThresholdLeft    220
#define WallAvoidRadius         800
#define SonarThreshold1         15
#define SonarThreshold2         30
#define SonarThreshold3         45

//#define SonarThreshold1         980
//#define SonarThreshold2         1800
//#define SonarThreshold3         2520

//Speaking constants
#define Joke           1
#define Offer          2
#define Obstacle       3
#define Comment        4
#define Welcome        5
#define Dance          6
#define JokeAnnounce   7
#define DanceAnnounce  8


#define JokeStart      1
#define JokeEnd        15
#define OfferStart     21    
#define OfferEnd       25
#define ObstacleStart  31
#define ObstacleEnd    36
#define CommentStart   51
#define CommentEnd     75
#define WelcomeStart   70
#define WelcomeEnd     75
#define DanceStart     81
#define DanceEnd       85
#define JokeAnnounceStart     100
#define JokeAnnounceEnd       104
#define DanceAnnounceStart    105
#define DanceAnnounceEnd      110

#define DelayJoke     120  // seconds  
#define DelayOffer    35  // seconds  
#define DelayComment  20  // seconds  
#define DelayWelcome  30


#define TimeStationary  30  // number of seconds to wait in one spot of the room

// cylon lights modes
#define CylonStandard         1
#define CylonOneDirection     2
#define CylonOtherDirection   3
#define CylonPigEyes          4
#define CylonOnePigEye        5
#define CylonRandomPigEye     6
#define CylonRandomMulti      7
#define CylonRandomSingle     8
#define CylonRandomInter      9
#define CylonRandomSparse     10
#define CylonOff              11

//Pins

#define InitSonarRead  22
#define Sonar1         23
#define Sonar2         24
#define Sonar3         25

#define PushButtonJoke   26
#define PushButtonDance  27

#define MoveSwitch     29
#define ModeSwitch    30
#define CylonReset     31

#define RotarySwitch1  33
#define RotarySwitch2  34
#define RotarySwitch3  35
#define RotarySwitch4  36

#define UserButton        37
#define RobotPwrToggle    38
#define RobotPowerSense   39
